# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AdSenseHost.V41.Model.AdClient do
  @moduledoc """


  ## Attributes

  *   `arcOptIn` (*type:* `boolean()`, *default:* `nil`) - Whether this ad client is opted in to ARC.
  *   `id` (*type:* `String.t`, *default:* `nil`) - Unique identifier of this ad client.
  *   `kind` (*type:* `String.t`, *default:* `adsensehost#adClient`) - Kind of resource this is, in this case adsensehost#adClient.
  *   `productCode` (*type:* `String.t`, *default:* `nil`) - This ad client's product code, which corresponds to the PRODUCT_CODE report dimension.
  *   `supportsReporting` (*type:* `boolean()`, *default:* `nil`) - Whether this ad client supports being reported on.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :arcOptIn => boolean(),
          :id => String.t(),
          :kind => String.t(),
          :productCode => String.t(),
          :supportsReporting => boolean()
        }

  field(:arcOptIn)
  field(:id)
  field(:kind)
  field(:productCode)
  field(:supportsReporting)
end

defimpl Poison.Decoder, for: GoogleApi.AdSenseHost.V41.Model.AdClient do
  def decode(value, options) do
    GoogleApi.AdSenseHost.V41.Model.AdClient.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AdSenseHost.V41.Model.AdClient do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
