# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AdSenseHost.V41.Model.AdUnitContentAdsSettingsBackupOption do
  @moduledoc """
  The backup option to be used in instances where no ad is available.

  ## Attributes

  *   `color` (*type:* `String.t`, *default:* `nil`) - Color to use when type is set to COLOR. These are represented as six hexadecimal characters, similar to HTML color codes, but without the leading hash.
  *   `type` (*type:* `String.t`, *default:* `nil`) - Type of the backup option. Possible values are BLANK, COLOR and URL.
  *   `url` (*type:* `String.t`, *default:* `nil`) - URL to use when type is set to URL.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :color => String.t(),
          :type => String.t(),
          :url => String.t()
        }

  field(:color)
  field(:type)
  field(:url)
end

defimpl Poison.Decoder, for: GoogleApi.AdSenseHost.V41.Model.AdUnitContentAdsSettingsBackupOption do
  def decode(value, options) do
    GoogleApi.AdSenseHost.V41.Model.AdUnitContentAdsSettingsBackupOption.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AdSenseHost.V41.Model.AdUnitContentAdsSettingsBackupOption do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
