# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AdSenseHost.V41.Model.CustomChannel do
  @moduledoc """


  ## Attributes

  *   `code` (*type:* `String.t`, *default:* `nil`) - Code of this custom channel, not necessarily unique across ad clients.
  *   `id` (*type:* `String.t`, *default:* `nil`) - Unique identifier of this custom channel. This should be considered an opaque identifier; it is not safe to rely on it being in any particular format.
  *   `kind` (*type:* `String.t`, *default:* `adsensehost#customChannel`) - Kind of resource this is, in this case adsensehost#customChannel.
  *   `name` (*type:* `String.t`, *default:* `nil`) - Name of this custom channel.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :code => String.t(),
          :id => String.t(),
          :kind => String.t(),
          :name => String.t()
        }

  field(:code)
  field(:id)
  field(:kind)
  field(:name)
end

defimpl Poison.Decoder, for: GoogleApi.AdSenseHost.V41.Model.CustomChannel do
  def decode(value, options) do
    GoogleApi.AdSenseHost.V41.Model.CustomChannel.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AdSenseHost.V41.Model.CustomChannel do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
