# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.AdSenseHost.V41.Model.ReportHeaders do
  @moduledoc """


  ## Attributes

  *   `currency` (*type:* `String.t`, *default:* `nil`) - The currency of this column. Only present if the header type is METRIC_CURRENCY.
  *   `name` (*type:* `String.t`, *default:* `nil`) - The name of the header.
  *   `type` (*type:* `String.t`, *default:* `nil`) - The type of the header; one of DIMENSION, METRIC_TALLY, METRIC_RATIO, or METRIC_CURRENCY.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :currency => String.t(),
          :name => String.t(),
          :type => String.t()
        }

  field(:currency)
  field(:name)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.AdSenseHost.V41.Model.ReportHeaders do
  def decode(value, options) do
    GoogleApi.AdSenseHost.V41.Model.ReportHeaders.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AdSenseHost.V41.Model.ReportHeaders do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
